/** Rational.java (Version .5) 
 *  
 *  Eine Klasse rationaler Zahlen mit Multiplikation
 *  ohne Nebenefeekte bei mult und toStringReduced
 */

public class Rational {

   // Datenelemente
   private int num;	// Zaehler
   private int denom; 	// Nenner


   // Konstruktoren
   public Rational() {
	num = 0;
	denom = 1;
   }

   public Rational(int n) {
	num = n;
	denom = 1;
   }

   public Rational(int num, int denom) {
	this(num);
	this.denom = denom;
   }


   // Methode: kuerzen
   public void reduce() {
 	int gcd = Gcd.gcd(num,denom);
        num /= gcd;
        denom /= gcd;
   }

   // Methode: erweitern
   public void extend(int factor) {
        num *= factor;
        denom *= factor;
   }

   // Methode: ausgeben in der Form a/b
   public String toString() {
	return (num + "/" + denom);
   }

   // Methode: gekuerzt ausgeben
   public String toStringReduced() {
	Rational out = new Rational(num,denom);
	out.reduce();
	return out.toString();
   }

   // Methode: multiplizieren
   public Rational mult(Rational p) {
	int gcd = Gcd.gcd(p.num,p.denom);
	int n = p.num/gcd;
	int d = p.denom/gcd;
	return new Rational(num*n, denom*d);
   }
}

// Rational.5
